// AudioSampleManager.h: interface for the AudioSampleManager class.
//
//////////////////////////////////////////////////////////////////////

#ifndef AFX_AUDIOSAMPLEMANAGER_H__76C53E0E_9B8E_4ADB_BB87_442385790C2F__INCLUDED_
#define AFX_AUDIOSAMPLEMANAGER_H__76C53E0E_9B8E_4ADB_BB87_442385790C2F__INCLUDED_
#ifdef WIN32
#include <windows.h>
#else
#include "VMutex.h"
#endif

#include <list>

class AudioSample;

class AudioSampleManager  
{
public:
	static AudioSampleManager* GetInstance();
	int GetAudioSample(AudioSample **ppAudioSample);
	int AudioSampleReleased(AudioSample *audioSample);
	virtual ~AudioSampleManager();
private:
	AudioSampleManager();
private:
	static AudioSampleManager *instance;
	std::list<AudioSample *> audioSamples;
#ifdef WIN32
	CRITICAL_SECTION audioSamplesMutex;
#else
        VMutex audioSamplesMutex;
#endif
};

#endif // !defined(AFX_AUDIOSAMPLEMANAGER_H__76C53E0E_9B8E_4ADB_BB87_442385790C2F__INCLUDED_)
