// G729Codec.h: interface for the G729Codec class.
//
//////////////////////////////////////////////////////////////////////

#ifndef AFX_G729CODEC_H__E1D2F0F0_DEA1_4BA2_89A9_03CBDEE26110__INCLUDED_
#define AFX_G729CODEC_H__E1D2F0F0_DEA1_4BA2_89A9_03CBDEE26110__INCLUDED_

#include "AudioCodec.h"

class G729Codec : public AudioCodec
{
public:
	G729Codec();
	virtual ~G729Codec();
	int StartEncoder();
	// need to call it ONCE before beginning the session (i.e. before the FIRST call to Encode())
	int StopEncoder();
	// call it after all the Encode calls have been completed (i.e. after the LAST call to Encode)
	int StartDecoder();
	// need to call it ONCE before beginning the session (i.e. before the FIRST call to Decode())
	int StopDecoder();
	// call it after all the Decode calls have been completed (i.e. after the LAST call to Decode)
	int Encode(void *input, int inputSizeBytes, void *output, int *outputSizeBytes);
	// input = an array of "short" where each short is one sample of PCM 8kHz 16bit mono
	// fill outputSizeBytes with size(bytes) of array output (should be long enough).
	// on return, it contains # of bytes in output
	int Decode(void *input, int inputSizeBytes, void *output, int *outputSizeBytes);
	// input = pointer to g729 encoded frame (10bytes/10milliseconds)
	// output = array of short. output format is PCM 8kHz 16bit(i.e. 2bytes/sample) mono
	// fill outputSizeBytes with size(bytes) of array output (should be long enough).
	// on return, it contains # of bytes in output
};

#endif // !defined(AFX_G729CODEC_H__E1D2F0F0_DEA1_4BA2_89A9_03CBDEE26110__INCLUDED_)
