#ifndef LIN_TYPES_H
#define LIN_TYPES_H
#ifndef WIN32
#include <stdio.h>
#include <stdarg.h>
#include "vtypes.h"
#include "VMutex.h"
#include "cpLog.h"
#define WORD  int32_t
#define DWORD int64_t
#define BOOL  bool
#define CRITICAL_SECTION  VMutex
#define EnterCriticalSection(x) (x)->lock()
#define LeaveCriticalSection(x) (x)->unlock()
#define DeleteCriticalSection(x) 
#define InitializeCriticalSection(x) 

enum SDI_SystemBitType
{
  SDI_LEVEL_NONE        = 0x00000000,
  SDI_LEVEL_ERROR       = 0x00010000, // system level
  SDI_LEVEL_SPECIAL     = 0x00020000,
  SDI_LEVEL_STATE_TRANS = 0x00040000,
  SDI_LEVEL_SIGNIFICANT = 0x00080000,
  SDI_LEVEL_ENTRY_EXIT  = 0x00100000,
  SDI_LEVEL_ARBITRARY   = 0x00200000,
  SDI_LEVEL_DETAILED    = 0x00400000,  SDI_EVENTLOG_ALARMS   = 0x20000000,
  SDI_SHOW_DATE         = 0x40000000, // 1 = display date in output
  SDI_SHOW_TIME         = 0x80000000, // 1 = display time in output
 
  SDI_EVENTA_DEBUG      = 0x3C000000, // Debugging  messages with alarm bit
  SDI_EVENTA_INFO       = 0x38000000, // Information Messages only with alarm bit
  SDI_EVENTA_NOTICE     = 0x34000000, // Normal but significant condition with alarm bit
  SDI_EVENTA_WARNING    = 0x30000000, // Warning conditionwith alarm bit
  SDI_EVENTA_ERR        = 0x2C000000, // Error with alarm bit
  SDI_EVENTA_CRIT       = 0x28000000, // Critical Condition with alarm bit
  SDI_EVENTA_ALERT      = 0x24000000, // Immediate action Needed with alarm bit
  SDI_EVENTA_EMERG      = 0x20000000, // System Unusable with alarm bit
 
  SDI_EVENT_DEBUG       = 0x1C000000, // Debugging  messages
  SDI_EVENT_INFO        = 0x18000000, // Information Messages only
  SDI_EVENT_NOTICE      = 0x14000000, // Normal but significant condition
  SDI_EVENT_WARNING     = 0x10000000, // Warning condition
  SDI_EVENT_ERR         = 0x0C000000, // Error
  SDI_EVENT_CRIT        = 0x08000000, // Critical Condition
  SDI_EVENT_ALERT       = 0x04000000, // Immediate action Needed
  SDI_EVENT_EMERG       = 0x00000000, // System Unusable
 
 
  SDI_EVENT_ALL         = 0x1C000000,  
  SDI_LEVEL_ALL         = 0x1FFF0000
};

class Tracer
{
    private:
public:
        Tracer() { };
        ~Tracer() { };
 
        void SetSystemMask(const unsigned long SystemMask) { };
        void SetFacilityName(const char * name) { facName = name;};
        void SetSubFacilityName(const char * name) { facName = name; };
        void tracef(const unsigned long mask, const char * str_, ...)
        {
            va_list ap; 
            va_start(ap, str_);
            char buf[4097];
            vsnprintf(buf, 4096, str_, ap);
            cpLog(LOG_DEBUG, "%s, %s", facName.c_str(), buf);
            va_end(ap);
        }
    private:
       string facName;
};

#endif

#endif
