#include "LGCallLeg.hxx"
#include "SipMsg.hxx"

LGCallLeg::LGCallLeg(const SipMsg& msg)
    : SipCallLeg(msg.computeCallLeg()),
      cseq(msg.getCSeq().encode())
{}

bool
LGCallLeg::operator == (const SipCallLeg& src) const
{
    cpLog(LOG_DEBUG, "in LGCallLeg::operator == ");
    bool res = SipCallLeg::operator==(src);
    if(res)
    {
	const LGCallLeg * ptr = dynamic_cast<const LGCallLeg*>(&src);
	if(ptr)
	    res  = res && (this->cseq == ptr->cseq);
    }
    return res;
}

bool
LGCallLeg::operator != (const SipCallLeg& src) const
{
    cpLog(LOG_DEBUG, "in LGCallLeg::operator != ");
    return (!operator==(src));
}

bool
LGCallLeg::operator < (const SipCallLeg& src) const
{
    cpLog(LOG_DEBUG, "in LGCallLeg::operator < ");
    bool res = SipCallLeg::operator<(src);
    if(res)
    {
	const LGCallLeg * ptr = dynamic_cast<const LGCallLeg*>(&src);
	if(ptr)
	    res  = res && (this->cseq < ptr->cseq);
    }
    return res;
}
