
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */

#ifndef _LG_PARAM__HXX
#define _LG_PARAM__HXX
#include <iostream>
#include "Data.hxx"

/**
 * container for LG's global params...
 */
class LGParam
{
public:
    static void print (ostream&);

    typedef enum {ORIGINATING=0, TERMINATING, REGISTRATION} Mode;
    typedef enum {REMOVE, OVERWRITE} RefreshType;
    typedef enum {IP, E164, PHONE, NONE} UserType;
    typedef enum {TCP, UDP} TransportType;
    static UserType User;
    static Mode Function;
    static TransportType Transport;
    static int TotalCalls;
    static int CPS;
    static int MaxRetry;
    static int CallHoldTime;
    static int RingTime;
    static int CleanUpTime;
    static int InviteTimeOut;
    static int RequestTimeOut;
    static int BurstRate;
    static int UDPPort;
    static int RTPPort;
    static bool SDPOff;
	static bool RPort;
	static bool Random;
    static char * NextHopHost;
    static char * NextHopPort;
//	static char * URIHost;
//	static char * URIPort;
    static int FromUrlPort;
    static char * FromUrl;
    static char * FromHost;
    static char * ToHost;
    static char * ToPort;
    static char * SessionName;
    static char * Secret;
    static Data * MsgData;
    static char * ContactHost;
    static char * ContactPort;
    static char * LeaseTime;
    static RefreshType Refresh;

protected:
    LGParam();
    ~LGParam();
};

#endif
