#ifndef  Cops_def_hxx
#define Cops_def_hxx

/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */



static const char* const Cops_def_hxx_Version =
    "$Id: Cops_def.hxx,v 1.16 2001/01/12 01:35:50 wbreu Exp $";
#include "global.h"
#include <string>

#define ENABLE_QOS   "ENABLE_QOS"
#define DISABLE_QOS  "DISABLE_QOS"

typedef enum
{
    M_PATH = 1,
    M_RESV = 2,
    M_PATH_ERR = 3,
    M_RESV_ERR = 4,
    M_QOS = 100,
    M_OSP = 101,
    M_LPDP = 102,
    M_USAGE = 103,
    M_MAX
} COPS_msg_type;

/**
  RSVP clienttype is always one, 
  Vocal specific client type starts with 100.
 */
typedef enum
{
    C_RSVP = 1,
    C_SIP = 100,
    C_MAX
} COPS_ClientType;

/// class containing keywords supported by the RSVP and SIP client types
class COPS_key
{
    public:
        // keywords used in the Authorization Request
	///
        static string source;
	///
        static string sourceDev;
	///
        static string callingNumber;
	///
        static string calledNumber;
	///
        static string user;
	///
        static string callId;
	///
        static string validAfter;
	///
        static string validUntil;
	///
        static string tokenSize;
	///
        static string token;

        // keywords used in the Usage Report
	///
        static string transactionId;
	///
        static string duration;

        //Keywords used for token validation
	///
        static string destination;

        ///
        string strClientType(COPS_ClientType cType) const
        {
            switch (cType)
            {
                case C_RSVP:
                    return ("C_RSVP");
                break;
                case C_SIP:
                    return ("C_SIP");
                break;
                default:
                    return "Unknown";
                break;
            }
        }
};


#endif
