// Copyright (c) 2002 Cathay Networks, Inc. All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
// 
// 1. Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright notice,
// this list of conditions and the following disclaimer in the documentation
// and/or other materials provided with the distribution.
// 
// 3. The names "VOCAL", "Vovida Open Communication Application Library", and
// "Vovida Open Communication Application Library (VOCAL)" must not be used to
// endorse or promote products derived from this software without prior written
// permission. For written permission, please contact vocal@vovida.org.
// 
// 4. Products derived from this software may not be called "VOCAL", nor may
// "VOCAL" appear in their name, without prior written permission.
// 
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT ARE DISCLAIMED.
// IN NO EVENT SHALL CATHAY NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR
// ANY DAMAGES IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//

// Copyright 2002 Cathay Networks, Inc. 

#ifndef Subsystem_hxx
#define Subsystem_hxx

#include <string>

namespace Vocal
{

class Subsystem : public std::string
{
   public:
      // Add new systems below
      static const Subsystem TEST;   

      static const Subsystem NONE; // default subsystem

      static const Subsystem UTIL;

      static const Subsystem PROV;
      static const Subsystem PROVS;
      static const Subsystem PROVC;
      static const Subsystem PROVDB;
      static const Subsystem PROVXML;

      static const Subsystem SIP;    // SIP Stack / Parser
      static const Subsystem SIPBASE;    // SIP Subsystem Code
      
      static const Subsystem NET;
      static const Subsystem PROXY;
      static const Subsystem REGISTRAR;
      static const Subsystem HUNT;
      static const Subsystem FORWARD;
      static const Subsystem PARK;
      static const Subsystem SPEED;
      static const Subsystem UA;
      static const Subsystem RESTRICT;
      static const Subsystem CPE;

      static const Subsystem RTSP;
      static const Subsystem RTP;
      static const Subsystem SDP;
      static const Subsystem HB;
      static const Subsystem RADIUS;
      static const Subsystem OSP;
      static const Subsystem TRIP;

      static const Subsystem LS;     // location service
      static const Subsystem FEAT;   // Feature
      
      static const Subsystem LB;     // Load Balancer
      static const Subsystem HOSTMAN;   // Host Manager
      static const Subsystem RESMAN;   // Resource Manager
      static const Subsystem REPO;   // Repository
      static const Subsystem TFTP;   // tftp service
      static const Subsystem CDR; 
      static const Subsystem SNMP; 
      static const Subsystem THREAD; 

      static const Subsystem VXML;
      
      static const Subsystem SERVICE;   

      
   private:
      Subsystem(const std::string& str) : std::string(str) {};
};
 
}

#endif // Subsystem.hxx
