package org.vovida.prov.psLib;

public class StringArrayField extends Field
{ 
    public StringArrayField(String name) 
    { 
	super(name); 
    } 

    public Filter like(String s) 
    { 
	return new Like(this, new Constant(s));
    } 

    public Filter eq(StringArrayField stringField) 
    { 
	return new Eq(this, stringField); 
    } 
             
    public Filter eq(String[] v) 
    { 
	return new Eq(this, new Constant(v)); 
    } 

    public Filter ne(StringArrayField stringField) 
    { 
	return new Eq(this, stringField); 
    } 

    public Filter ne(String[] v) 
    { 
	return new Eq(this, new Constant(v)); 
    } 

    public Filter lt(StringArrayField stringField) 
    { 
	return new Lt(this, stringField); 
    } 

    public Filter lt(String[] v) 
    { 
	return new Lt(this, new Constant(v)); 
    } 

    public Filter gt(StringArrayField stringField) 
    { 
	return new Gt(this, stringField); 
    } 

    public Filter gt(String[] v) 
    { 
	return new Gt(this, new Constant(v));
    } 

    public Filter le(StringArrayField stringField) 
    { 
	return new Le(this, stringField); 
    } 

    public Filter le(String[] v) 
    { 
	return new Le(this, new Constant(v));
    } 

    public Filter ge(StringArrayField stringField) 
    { 
	return new Ge(this, stringField); 
    } 

    public Filter ge(String[] v) 
    { 
	return new Ge(this, new Constant(v));
    } 

    public StringArrayAssignment assign(StringArrayField v) 
    { 
	return new StringArrayAssignment(this, v); 
    } 

    public StringArrayAssignment assign(String[] v) 
    { 
	return new StringArrayAssignment(this, new Constant(v)); 
    } 

    public StringArrayAssignment assign(java.util.List v) 
    { 
	return new StringArrayAssignment(this, new Constant(v)); 
    } 

    public String[] bound() 
    { 
	if (!isBound()) {
	    throw new NotBoundException(); 
	} 
               
	return value; 
    } 
               
    void bind(String v) 
    { 
	java.util.List l = new java.util.ArrayList();
	// tokenize by comma
	java.util.StringTokenizer tok = 
	    new java.util.StringTokenizer(v, ",", false);
	while (tok.hasMoreTokens()) {
	    l.add(tok.nextToken());
	}

	value = new String[l.size()];
	java.util.Iterator it = l.iterator();
	int i = 0;
	while (it.hasNext()) {
	    value[i++] = BaseField.decodeString((String)(it.next()));
	}
    } 

    private String[] value; 
} 
