<?php
// Copyright (c) 2002 Cathay Networks, Inc. All rights reserved.
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
// 
// 1. Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
// 
// 2. Redistributions in binary form must reproduce the above copyright notice,
// this list of conditions and the following disclaimer in the documentation
// and/or other materials provided with the distribution.
// 
// 3. The names "VOCAL", "Vovida Open Communication Application Library", and
// "Vovida Open Communication Application Library (VOCAL)" must not be used to
// endorse or promote products derived from this software without prior written
// permission. For written permission, please contact vocal@vovida.org.
// 
// 4. Products derived from this software may not be called "VOCAL", nor may
// "VOCAL" appear in their name, without prior written permission.
// 
// THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED WARRANTIES,
// INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT ARE DISCLAIMED.
// IN NO EVENT SHALL CATHAY NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR
// ANY DAMAGES IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
// ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//

if (!function_exists('is_a')) {
  function is_a($class, $anc_class) {
    if (!$class) {
      return false;
    }

    if (strcasecmp($class, $anc_class) == 0) {
      return true;
    }

    return is_a(get_parent_class($class), 
		$anc_class);
  }
}

class Foo
{
  var $fooVar = "fooVar";
  function Foo()
  {
    print get_class($this).'
';
    $cvars = &get_class_vars(get_class($this));
    var_dump($cvars);
  }

  function specific()
  {
    return "fooSpecific";
  }
}

class Bar extends Foo
{
  var $barVar = "barVar";

  function Bar()
  {
    $this->Foo();
  }

  function specific()
  {
    return "barSpecific";
  }
}

class Baz extends Bar
{
  var $bazVar = "bazVar";

  function Bar()
  {
    $this->Bar();
  }

  function specific()
  {
    return "bazSpecific";
  }
}

$foo = new Foo();
$bar = new bar();
$baz = new Baz();

print "bar is_a foo: ".is_a($bar, get_class($foo)).'
';
print "baz is_a foo: ".is_a($baz, get_class($foo)).'
';
print "bar is_a baz: ".is_a($bar, get_class($baz)).'
';

print "bar is_a 'Foo': ".is_a($bar, 'foo').'
';
?>

