
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
static const char* const TrapAgentC_cxx_Version =
    "$Id: TrapAgentC.cxx,v 1.15 2001/10/19 20:46:54 icahoon Exp $";
#include "TrapAgentC.hxx"
#include "ServerTable.hxx"
#include <assert.h>


#ifdef __cplusplus
extern "C"
{
#endif

    void *
    TrapAgent_create1()
    {
        TrapAgent* obj = 0;
        obj = new TrapAgent();
        return (void *)obj;
    }


    void
    TrapAgent_free( void *objPtr)
    {
        assert(objPtr);
        TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
        delete obj;
    }

    void
    TrapAgent_run(void *objPtr)
    {
        assert(objPtr);
        TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
        obj->run();
    }

    void *
    TrapAgent_GetApplicationList(void *objPtr)
    {
        assert(objPtr);
        TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
        return (obj->GetApplicationList());
    }

    applInfoT
    TrapAgent_GetApplication(void *objPtr, int index)
    {
        assert(objPtr);
        TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
        return (obj->GetApplication(index));
    }

    int
    TrapAgent_GetStackPortFromIndex(void * objPtr, int index)
    {
        assert(objPtr);
        TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
        return (obj->GetStackPortFromIndex(index));
    }

    int
    TrapAgent_GetApplPortFromIndex(void * objPtr, int index)
    {
        assert(objPtr);
        TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
        return (obj->GetApplPortFromIndex(index));
    }

    int
    TrapAgent_GetNumOfApps(void *objPtr)
    {
        assert(objPtr);
        TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
        return (obj->GetNumOfApps());
    }

    int
    TrapAgent_GetNextIndex(void *objPtr, int index, enum ServerType type)
    {
        assert(objPtr);
        TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
        return (obj->GetNextIndex(index, type));
    }

    serverInfoT 
    TrapAgent_GetServerFromIndex(void *objPtr, unsigned long index)
    {
	assert(objPtr);
	TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
	return (obj->GetServerFromIndex(index));
    }

    unsigned long 
    TrapAgent_GetNextServerIndex(void *objPtr, unsigned long index)
    {
	assert(objPtr);
	TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
	return (obj->GetNextServerIndex(index));
    }

    void
    TrapAgent_ClearServerCache(void *objPtr)
    {
	assert(objPtr);
	TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
	return (obj->ClearServerCache());
    }


    void
    TrapAgent_InsertServer(void *objPtr, serverInfoT aServer)
    {
	assert(objPtr);
	TrapAgent* obj = static_cast < TrapAgent* > (objPtr);
	return (obj->InsertServer(aServer));
    }

#ifdef __cplusplus
} /*close extern C*/
#endif
