#ifndef JSCOMMON_HXX
#define JSCOMMON_HXX

/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */



static const char* const JSCommon_hxx_Version =
    "$Id$";

#include <string>

/**
 */

// Request Types
const string CONNECT = "101";
const string DISCONNECT = "102";
const string ANSWER = "103";
const string TRANSFER = "104";

const string CALLCREATE = "150";
const string REGISTER = "151";
const string CHKREGISTER = "152";

const int TYPECONNECT = 101;
const int TYPEDISCONNECT = 102;
const int TYPEANSWER = 103;
const int TYPETRANSFER = 104;

const int TYPECALLCREATE = 150;
const int TYPEREGISTER = 151;
const int TYPECHKREGISTER = 152;


// Response Types
const string CONNECTRESP = "201";
const string DISCONNECTRESP = "202";
const string ANSWERRESP = "203";
const string TRANSFERRESP = "204";

const string CALLCREATERESP = "250";
const string REGISTERRESP = "251";
const string CHKREGISTERRESP = "252";

const int TYPECONNECTRESP = 201;
const int TYPEDISCONNECTRESP = 202;
const int TYPEANSWERRESP = 203;
const int TYPETRANSFERRESP = 204;

const int TYPECALLCREATERESP = 250;
const int TYPEREGISTERRESP = 251;
const int TYPECHKREGISTERRESP = 252;


// Notification Types
const string CALLCREATED = "301";
const string CALLACTIVE = "302";
const string CALLINVALID = "303";

const string CONNCREATED = "311";
const string CONNINPROGRESS = "312";
const string CONNALERTING = "313";
const string CONNCONNECTED = "314";
const string CONNDISCONNECTED = "315";
const string CONNFAILED = "316";
const string CONNUNKNOWN = "317";

const string TERMCONNCREATED = "321";
const string TERMCONNRINGING = "322";
const string TERMCONNACTIVE = "323";
const string TERMCONNPASSIVE = "324";
const string TERMCONNDROPPED = "325";
const string TERMCONNUNKNOWN = "326";
const string TERMCONNHELD = "327";


// Value Types
const string JS_SUCCESS = "1";
const string JS_FAILED = "2";
const string JS_INPROGRESS = "3";
const string JS_UNKNOWN = "4";

// enumeration of values of branches in Via
enum
{
    REDIRECT_CTRL = 201,
    REDIRECT_JSN	= 202,
    REDIRECT_JSD	= 203,
    CONTACT_CTRL	= 301,
    CONTACT_JSN	= 302,
    CONTACT_JSD	= 303
};



#endif
