
/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */
static const char* const UiThread_cxx_Version =
    "$Id: UiThread.cxx,v 1.23 2001/03/22 02:49:21 neethak Exp $";
//Standard Include
#include <sys/types.h>
#include <errno.h>
#include <sys/wait.h>
#include <sys/shm.h>
#include <sys/ipc.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/shm.h>
#include <sys/ipc.h>
#include <strstream.h>
#include <fstream.h>
#include <signal.h>
#include <unistd.h>
#include <string.h>
#include <list>


//User defined

#include "UiThread.hxx"
#include "SystemConfig.hxx"
#include "AgentApi.hxx"
#include "ClientSession.hxx"

Sptr < UiThread > UiThread::theUiThread = 0;

Sptr < UiThread >
UiThread::instance()
{
    if ( theUiThread == 0 )
    {
        theUiThread = new UiThread;
    }
    return theUiThread;
}

UiThread::UiThread() : ThreadIf()
{
    _serverSocket = new TcpServerSocket(NWMUISOCKET);

}

UiThread::~UiThread()
{
    _serverSocket->close();
}

void
UiThread::thread()
{
    Connection conn;
    ClientSession *aSession;
    list<ClientSession*> listOfSessions;
    list<ClientSession*>::iterator sessionIter;

    //Loop through for Incoming messages
    for (; ; )
    {
        _serverSocket->accept(conn);
        aSession = new ClientSession;
        listOfSessions.push_back(aSession);
        aSession->setConnection(conn);
        cpLog(LOG_DEBUG, "Accepted connection:%s" , conn.getDescription().c_str() );
        aSession->run();

        for(sessionIter = listOfSessions.begin(); sessionIter != listOfSessions.end(); sessionIter++)
        {
           if((*sessionIter)->toBeDeleted()){
                ClientSession* ses = (*sessionIter);
		ses->exit();
                listOfSessions.erase(sessionIter);
                delete ses;
                break;
           }
        }
    }
}
