#!/bin/sh
#
# $Id$
#
# ====================================================================
# The Vovida Software License, Version 1.0 
# 
# Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
# 
# 3. The names "VOCAL", "Vovida Open Communication Application Library",
#    and "Vovida Open Communication Application Library (VOCAL)" must
#    not be used to endorse or promote products derived from this
#    software without prior written permission. For written
#    permission, please contact vocal\@vovida.org.
# 
# 4. Products derived from this software may not be called "VOCAL", nor
#    may "VOCAL" appear in their name, without prior written
#    permission of Vovida Networks, Inc.
# 
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
# NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
# NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
# IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
# DAMAGE.
# 
# ====================================================================
# 
# This software consists of voluntary contributions made by Vovida
# Networks, Inc. and many individuals on behalf of Vovida Networks,
# Inc.  For more information on Vovida Networks, Inc., please see
# <http://www.vovida.org/>.
#
# $Log$
# Revision 1.6  2000/08/12 00:15:00  icahoon
# added license
#
# Revision 1.5  2000/07/28 07:00:34  icahoon
# minor fixes, added ua
#
# Revision 1.4  2000/07/25 23:41:34  icahoon
# removed env variables
#
# Revision 1.3  2000/07/24 22:34:38  icahoon
# moved to vocal
#
# Revision 1.2  2000/07/05 22:58:44  hyu
# Merging BRANCH_CURD into HEAD.
#
# Revision 1.1.2.2  2000/06/23 08:44:37  icahoon
# minor fixes
#
# Revision 1.1.2.1  2000/06/20 23:29:55  icahoon
# added html interface for allinone server
#
#

# disable filename globbing
set -f

CMDLINE=0

#VOCAL_DIR=/usr/local/vocal
#VPS_PORT=6005

export HOSTNAME=`/bin/uname -n`
export HOST=${HOSTNAME%%.*}

if [ "$1" = "-nc" ]
then

    shift
    CMDLINE=1
fi

if [ -f config/port ]
then
    VPS_PORT=`cat config/port`
fi

export NO_DAEMON=1
export SIP_NO_RETRAN=1

export VLOG_LEVEL=7
#export VLISTENER_PORT=6006
#export VPS_SERVER=${HOST}
#export VCONFIG_DIR=${VOCAL_DIR}/provisioning_data/Config
#export VLOG_FILE_NAME=${VOCAL_DIR}/provisioning_data/Logs/pserver_log
#export VPS_FILESYSTEM=${VOCAL_DIR}/provisioning_data

#export PATH=/usr/local/jdk1.2.2/bin:$PATH
#export CLASSPATH=./provisioning/java/lib/psClient.jar:/usr/local/jdk1.2.2/jre/lib/rt.jar

export VPS_LOG_FILE=pserver.`date -u +"%Y-%m-%d.%T"`.log.txt
export VPS_CURRENT_LOG_FILE=current.txt

if [ $CMDLINE -eq 0 ]
then
    echo Content-type: text/html
    echo

    cat << EOF
<html>

<!-- #include virtual="/vocal/common/copyright"-->

<head> 
	<title>Provisioning Server Start</title> 
	<link rel="stylesheet" href="/vocal/common/style.css" type="text/css">
</head>

<body>
<table border="0" cellspacing="0" cellpadding="10" width="100%">
    <tr>
	<td colspan="4" valign="bottom" align="left" bgcolor="#D2C8B6">
	<h3>Provisioning Server Start</h3>
	</td>
    </tr>

    <tr>
	<td colspan="4" bgcolor="#FFFFFF">
    	    &nbsp;
	</td>
    </tr>

    <tr>
	<td colspan="4" bgcolor="#FFFFFF">
<pre>
EOF

fi

TOP=`top b n 1 | grep " pserver" | head -1`
TOP=`echo $TOP`
PROCESS=${TOP%% *}

if [ "$PROCESS" != "" ]
then
    echo Already started.
else
    echo Starting...

    echo "./pserver > log/$VPS_LOG_FILE  2>&1 &"
    ./pserver > log/$VPS_LOG_FILE 2>&1 &

    cd log
    /bin/ln -sf $VPS_LOG_FILE $VPS_CURRENT_LOG_FILE 
    cd ..

#    echo '<ul>'
#    echo VPS_PORT=$VPS_PORT
#    echo VLOG_LEVEL=$VLOG_LEVEL
#    echo VPS_SERVER=$VPS_SERVER
#    echo VCONFIG_DIR=$VCONFIG_DIR
#    echo VLOG_FILE_NAME=$VLOG_FILE_NAME
#    echo VPS_FILESYSTEM=$VPS_FILESYSTEM
#    echo '</ul>'

fi

if [ $CMDLINE -eq 0 ]
then

    echo '<hr><br>'
    echo '<ul>'
    echo '<br>'
    top b n 1 | head -n 9 -
    top b n 1 | grep " pserver"
    echo '</ul>'
    cat <<EOF
</pre>		
	</td>
    </tr>

    <tr>
	<td colspan="4" bgcolor="#FFFFFF">
	    &nbsp;
	</td>
    </tr>

</table>
</body>
</html>
EOF

fi


