#ifndef INCLUDED_Q931Base_hxx
#define INCLUDED_Q931Base_hxx

/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2000 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */



static const char* const Q931Base_hxx_Version = 
"$Id: Q931Base.hxx,v 1.6 2000/12/18 23:47:37 bko Exp $";

#include "ptlib.h"
#include "h225.h"
#include "q931.h"

namespace router
{
    // Definitions specific to OpenH323

    typedef H225_H323_UserInformation H225UserInformation;
    typedef H225_H323_UU_PDU_h323_message_body H225TheMessge;

    class Q931Base: public H225UserInformation
    {
    public:
        Q931Base();

        const Q931& getQ931() const;
 
        Q931& getQ931();
 
        const H225TheMessge& m() const;

        H225TheMessge& m();

        //BOOL GetDestinationE164(PString & number) const;//???
 
    protected:
        //void BuildQ931();//???
 
        // Even though we generally deal with the H323 protocol (H225) it is
        // actually contained within a field of the Q931 protocol.
        Q931 q931pdu_;
    };

    //----------------------------
    // Inline methods
    //----------------------------

    inline const Q931& Q931Base::
    getQ931() const
    {
        return q931pdu_;
    }

    inline Q931& Q931Base::
    getQ931()
    {
        return q931pdu_;
    }

    inline const H225TheMessge& Q931Base::
    m() const
    {
        return m_h323_uu_pdu.m_h323_message_body;
    }

    inline H225TheMessge& Q931Base::
    m()
    {
        return m_h323_uu_pdu.m_h323_message_body;
    }

}

#endif
