#if !defined(RAS_COMMON_HXX)
#define RAS_COMMON_HXX

/* ====================================================================
 * The Vovida Software License, Version 1.0 
 * 
 * Copyright (c) 2001 Vovida Networks, Inc.  All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 * 
 * 3. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must
 *    not be used to endorse or promote products derived from this
 *    software without prior written permission. For written
 *    permission, please contact vocal@vovida.org.
 *
 * 4. Products derived from this software may not be called "VOCAL", nor
 *    may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, TITLE AND
 * NON-INFRINGEMENT ARE DISCLAIMED.  IN NO EVENT SHALL VOVIDA
 * NETWORKS, INC. OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT DAMAGES
 * IN EXCESS OF $1,000, NOR FOR ANY INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 * 
 * ====================================================================
 * 
 * This software consists of voluntary contributions made by Vovida
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see
 * <http://www.vovida.org/>.
 *
 */


static const char* const RasCommon_hxx_Version = 
    "$Id: RasCommon.hxx,v 1.2 2002/05/15 07:33:56 icahoon Exp $";

#define CONFIG_ERROR    5

#define SEND_FAILED     10
#define RECEIVE_FAILED  11
#define DECODE_FAILED   12
#define RETRY_EXPIRY    13

#define GCF             SUCCESS
#define GRJ             20
#define RCF             SUCCESS
#define RRJ             30
#define UCF             SUCCESS
#define URJ             40
#define ACF             SUCCESS
#define ARJ             50
#define DCF             SUCCESS
#define DRJ             60
#define LCF             SUCCESS
#define LRJ             70
#define RAC             SUCCESS

#define HUH             80

#define log_debug(cout)     if ( !myConfig.debug() ); else cout

#define zMessage_Type                       "Message Type"
#define zRas_Address                        "RAS Address"
#define zCall_Signaling_Address             "Call Signaling Address"
#define zDestination_Call_Signaling_Address "Destination Call Signaling Address"
#define zEndpoint_Id                        "Endpoint Id"
#define zSequence_Number                    "Sequence Number"
#define zEndpoint_Type                      "Endpoint Type"
#define zPhone_Number                       "Phone Number"
#define zUser                               "User"
#define zDestination_Phone_Number           "Destination Phone Number"
#define zDestination_User                   "Destination User"
#define zProduct_Id                         "Product Id"
#define zVersion_Id                         "Version Id"
#define zCounty_Code                        "County Code"
#define zDiscovery_Complete                 "Discovery Complete"
#define zTime_To_Live                       "Time To Live"
#define zExtension                          "Extension"
#define zManufacturer_Code                  "Manufacturer Code"
#define zCall_Model                         "Call Model"
#define zCRV                                "CRV"
#define zConference_Id                      "Conference Id"
#define zCall_Id                            "Call Id"
#define zBandwidth                          "Bandwidth"
#define zAnswer_Call                        "Answer Call"
#define zMC                                 "MC"
#define zMulticast                          "Multicast"
#define zAddress                            "Address"
#define zOut_of_Resources                   "Out of Resources"
#define zRetry_Count                        "Retry Count"
#define zRetry_Delay                        "Retry Delay"
#define zKeep_Alive                         "Keep Alive"
#define zGatekeeper_Id                      "Gatekeeper Id"
#define zGatekeeper_Address                 "Gatekeeper Address"

#define PROTOCOL_ID                         "0.0.8.2250.0.4"

#endif // !defined(RAS_COMMON_HXX)
